﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HeuristicLab.Services.Deployment {
  [DataContract(Name = "PluginDescription")]
  public class PluginDescription  {

    [DataMember(Name = "Name")]
    private string name;
    public string Name {
      get { return name; }
    }

    [DataMember(Name = "Version")]
    private Version version;
    public Version Version {
      get { return version; }
    }


    [DataMember(Name = "Dependencies")]
    private List<PluginDescription> dependencies;
    public List<PluginDescription> Dependencies {
      get { return dependencies; }
    }

    public PluginDescription(string name, Version version, IEnumerable<PluginDescription> dependencies) {
      this.name = name;
      this.version = version;
      this.dependencies = new List<PluginDescription>(dependencies); //.AsReadOnly();
    }

    public PluginDescription(string name, Version version)
      : this(name, version, Enumerable.Empty<PluginDescription>()) {
    }
  }
}
